/****************************************************************************
 * 
 * DocumentADT.h
 * 
 * Public functions, structures and constants for the Document Abstract Data Type
 * 
 ****************************************************************************/

#ifndef __DOCUMENTADT__
#define __DOCUMENTADT__

#include "Structs.h"

DocumentList			GetDocumentList										(void);
OSErr						DocumentError											(void);
void						CreateDocumentList									(void);
DocumentReference		CreateDocument											(DocumentList list, DocumentType documentType);
short						CountDocuments											(DocumentList list);
void						DestroyDocumentList									(DocumentList list);
void						DestroyDocument										(DocumentReference document);
DocumentReference		GetFirstDocument										(DocumentList list);
DocumentReference		GetLastDocument										(DocumentList list);

//
// --- Acessors
//

short						GetDocumentNumber										(DocumentReference document);
DocumentType			GetDocumentType										(DocumentReference document);
void						GetDocumentName										(DocumentReference document, StringPtr documentName);
DocumentReference		GetDocumentNextDocument								(DocumentReference document);
DocumentReference		GetDocumentPreviousDocument						(DocumentReference document);
unsigned short			GetDocumentNumberOfChanges							(DocumentReference document);
WindowPtr   			GetDocumentWindow										(DocumentReference document);
ElementList 			GetDocumentElementList								(DocumentReference document);
unsigned long			GetDocumentChangeLevel								(DocumentReference document);
Rect						GetDocumentCanvasRect								(DocumentReference document);
short						GetDocumentMaxWidth									(DocumentReference document);
short						GetDocumentMaxHeight									(DocumentReference document);


//
// --- Manipulators
//

void						SetDocumentType										(DocumentReference document, DocumentType documentType);
void						SetDocumentName										(DocumentReference document, ConstStr63Param documentName);
void						SetDocumentNextDocument								(DocumentReference document, DocumentReference next);
void						SetDocumentPreviousDocument						(DocumentReference document, DocumentReference previous);
void						SetDocumentNumberOfChanges							(DocumentReference document, unsigned short numberOfChanges);
void						SetDocumentWindow										(DocumentReference document, WindowPtr window);
void						SetDocumentElementList								(DocumentReference document, ElementList list);
void						SetDocumentChangeLevel								(DocumentReference document, unsigned long level);
void						SetDocumentMaxWidth									(DocumentReference document, short maxWidth);
void						SetDocumentMaxHeight									(DocumentReference document, short maxHeight);

#endif
