/****************************************************************************
 * 
 * Assertion.c
 *
 ****************************************************************************/

#include "Assertion.h"
#include "StringUtils.h"

/*****************************************************************************
 * 
 * DOAssert
 * 
 * If the specified condition is false, generate a call to DebugStr
 *
 *  NOTE: Compiled and called via Assert(...) only if __USEASSERTIONS__ is true
 * 
 *****************************************************************************/

#if __USEASSERTIONS__

void DoAssert(Boolean condition, char *message)
{
	if (condition == false)
	{
		Str255 debugMsg;
		CToPString(message, debugMsg);
		DebugStr(debugMsg);
	}
}

#endif
