/****************************************************************************
 * 
 * StringUtils.h
 * 
 ****************************************************************************/

#ifndef __STRINGUTILS__
#define __STRINGUTILS__

// --- CHARACTERS

char				UpperChar						(char c);

// --- C STRINGS

short				CStringCompare					(const char *s1, const char *s2, Boolean caseSensitive);
void				CStringConcat					(char *s1, const char *s2);
Boolean			CStringEqual					(const char *s1, const char *s2, Boolean caseSensitive);
long				CStringLength					(const char *cs);
void				CToPString						(const char *cs, StringPtr ps);

// --- PASCAL STRINGS

void				PStringConcat					(StringPtr s1, StringPtr s2);
void				PStringCopy						(StringPtr orginal, StringPtr duplicate);
void				PToCString						(StringPtr ps, char *cs);

// --- TEXT BLOCKS

void 				PStringToText					(const StringPtr pString, 	Handle textBlock);
void 				CStringToText					(const char *cString, 		Handle textBlock);
void 				TextToPString					(const Handle textBlock, 	StringPtr pString);
void 				TextToCString					(const Handle textBlock, 	char *cString, Size maxLen);

// --- DATA TYPES

void				OSTypeToCString				(OSType type, char *buffer);
void				OSTypeToPString				(OSType type, char *buffer);

// --- MISC SUPPORT

OSErr				VersionString					(short rID, StringPtr version);

#endif
